﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PIbd_22_Kalyshev_Y_V_MotorBoat_Base
{
    internal class BoatCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xBoat = x as DrawningObjectBoat;
            var yBoat = y as DrawningObjectBoat;
            if (xBoat == null && yBoat == null)
            {
                return 0;
            }
            if (xBoat == null && yBoat != null)
            {
                return 1;
            }
            if (xBoat != null && yBoat == null)
            {
                return -1;
            }
            if (xBoat.GetBoat.GetType().Name != yBoat.GetBoat.GetType().Name)
            {
                if (xBoat.GetBoat.GetType().Name == "DrawningBoat")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xBoat.GetBoat.Boat.Speed.CompareTo(yBoat.GetBoat.Boat.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xBoat.GetBoat.Boat.Weight.CompareTo(yBoat.GetBoat.Boat.Weight);
        }
    }
}
