﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PIbd_22_Kalyshev_Y_V_MotorBoat_Base
{
    internal class DrawningObjectBoat : IDrawningObject
    {
        private DrawningBoat _boat = null;
        public DrawningObjectBoat(DrawningBoat boat)
        {
            _boat = boat;
        }
        public float Step => _boat?.Boat?.Step ?? 0;
        public DrawningBoat GetBoat => _boat;
        public void DrawningObject(Graphics g)
        {
            _boat?.DrawTransport(g);
        }
        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _boat?.GetCurrentPosition() ?? default;
        }
        public string GetInfo() => _boat?.GetDataForSave();
        public void MoveObject(Direction direction)
        {
            _boat.MoveTransport(direction);
        }
        public void SetObject(int x, int y, int width, int height)
        {
            _boat.SetPosition(x, y, width, height);
        }
        public static IDrawningObject Create(string data) => new DrawningObjectBoat(data.CreateDrawningBoat());
        public bool Equals(IDrawningObject? other)
        {
            if (other == null)
            {
                return false;
            }
            var otherBoat = other as DrawningObjectBoat;
            if (otherBoat == null)
            {
                return false;
            }
            var boat = _boat.Boat;
            var otherBoatBoat = otherBoat._boat.Boat;
            if (boat.GetType().Name != otherBoatBoat.GetType().Name)
            {
                return false;
            }
            if (boat.Speed != otherBoatBoat.Speed)
            {
                return false;
            }
            if (boat.Weight != otherBoatBoat.Weight)
            {
                return false;
            }
            if (boat.BodyColor != otherBoatBoat.BodyColor)
            {
                return false;
            }
            if (boat is EntitySpeedboat speedboat && otherBoatBoat is EntitySpeedboat otherSpeedboatSpeedboat)
            {
                if (speedboat.DopColor != otherSpeedboatSpeedboat.DopColor)
                {
                    return false;
                }
                if (speedboat.BodyKit != otherSpeedboatSpeedboat.BodyKit)
                {
                    return false;
                }
                if (speedboat.Wing != otherSpeedboatSpeedboat.Wing)
                {
                    return false;
                }
                if (speedboat.SportLine != otherSpeedboatSpeedboat.SportLine)
                {
                    return false;
                }
            }
            return true;
        }
    }
}
